;tuner TEA5767 wersja EP
;definiowanie staych
;
;obsuga pamieci eeprom
;reset eeprom - przy wcinitym klawiszu mem wczy zasilanie
;komorka 00h zawiera informacje ile stacji jest zapisanych
;
#define key_mono PORTB, 1		;klawisz nr 1
#define key_mem PORTB, 2		;klawisz nr 2
#define ir_in PORTB, 0		;wejscie czujnika IR
#define buzer PORTC, 5			;sygnalizator dzwiekowy
;
#define dph 20h				;starszy bajt pomocniczy
#define dpl 21h				;mlodszy bajt pomocniczy
#define licznik 22h				;mlodszy bajt pomocniczy
#define stos 23h				;mlodszy bajt pomocniczy
#define tuner_data1 24h				;
;						data.7=1 =>szukanie w gore
;						data.6-data.5 => czuosc    00 - niedozwolony, 01 - czulosc max, 11 - czuosc min
;						data.4=1 => FM europe, 0=> FM Japon
;						data.3=1 => mono , 0=> stereo
;						data.2=1 => kana R - mute
;						data.1=1 => kana L - mute
;						data.0=1 => port spw ustawiony
#define mono tuner_data1, 3		;1=mono 0=stereo
#define tuner_data2 25h				;czestotliwosc tunera MSB
#define tuner_data3 26h				;czestotliwosc tunera LSB
#define var_mem 27h				;
#define pom 28h				;rejestr pomocniczy
#define i2cdata 29h		;dane wysylane przez 
#define licznik1 2ah				;mlodszy bajt pomocniczy
#define bit_reg 2bh			;rejestr w ktorym korzysta sie z bitow
#define stos3 2ch				;mlodszy bajt pomocniczy
#define stos1 2dh				;mlodszy bajt pomocniczy
#define adr_eeprom 2eh		;adres eeprom do odczytu
#define data_rd 2fh			;dane przeznaczone do zapisu do eeprom
#define nr_stacji 30h		;ktora z komorek pamieci jest grana
;
	list p=16F876A			;okreslenie typu procesora
	#include p16f876A.inc	;dolaczenie pliku z nazwami

;konfiguracja procesora
	__config _XT_OSC &_WDT_OFF &_PWRTE_ON &_BODEN_OFF &_DEBUG_OFF &_CP_OFF &_CPD_OFF &_LVP_OFF;
;OSC:
;	LP - low power - zewnetrzny kwarc zegarkowy 32kHz
;	XT - kwarc 455kHz - 4MHz
;	HS - kwarc 8-16MHz
;	RS - zewnetrzny RC
;
;WDT - WATCHDOG
;PWRTE - ON - po wlazeniu zasilania 72ms zwloki (reset) do ustabilizowania napicia
;BODEN - reset przy obnizebiu Udd - wylacz dla 3,3V
;CP - ochrona pamici programu przed odczytem
;CPD - ochrona pameci eeprom przed odczytem
;LVP - off programowanie z ISP - RB3 I/O
;
org 0
	goto start
org h'04'
;f=Fosc/8/prscaler/tmr0
;	movlw h'08' 				;wpisanie do PC adresu powyzej 2kB
;	movwf pclath
	call timer0_int
	retfie
;tablica wlasnych znakow LCD
;TAB_BAT0 
;	ADDWF PCL, 1
;	RETLW b'00001110'	;bat 0/5C
;
start
	bcf status, rp0		;bank 0
	clrf portb			;wyzerowanie portu zatrzaskowego portu B
	clrf intcon			; blokada przerwan
	bsf intcon, tmr0ie	
	bsf status, rp0		;bank1
	movlw b'00000111'			
	movwf trisb			;wejscia klawisze
	movlw b'00101111'			; 
	movwf trisa			;wyjscia; AN0 - wejscie ADC
	movlw h'00'			; 
	movwf trisc			;wyjscia
	bcf option_reg, 7	;wlaczenie rezystorow podciagajacych
	bsf pcon, 0			;BOR OFF
	bcf status, rp0		;bank0
	movlw h'00'			; 
	movwf sspcon 		;wyjscia
	movlw h'00'			; 
	movwf ccp2con 		;PWM2 i Comparator2 off
;
	movlw h'00'			; 
	movwf ccp1con 		;PWM1 i Comparator1 off
;
	bsf status, rp0		;bank 1
	movlw b'00000000'			; 
	movwf sspstat 		;I2C 
	movlw b'0000000'			; 
	movwf sspcon2 		;I2C off - udostepnienie linii SDA i CLK
	bcf status, rp0		;bank 0
	movlw b'00001000'			; 
	movwf sspcon 		;I2C off - udostepnienie linii SDA i CLK
;
	movlw h'00'			; 
	movwf rcsta 		;serial port off
	movlw h'00'			; 
	movwf t1con 		;timer 1 off
	movlw h'00'			; 
	movwf t2con 		;timer 2 off
	movlw h'00'			; 
	movwf t2con 		;timer 2 off
	bsf status, rp0		;bank1
	movlw b'00000000'	; rezystory wlaczone; timer fosc/4/256 
	movwf option_reg 		
	bcf status, rp0		;bank0
;
	movlw h'A1'			; 
	movwf adcon0 		;ADC on AN4 (RA5)
	bsf status, rp0		;bank1
	movlw b'00000101'			; shift - L; 
	movwf adcon1 		;AN0 i AN1 sa liniami analogowymi iAN3 = +ref
	bcf status, rp0		;bank0
	movlw b'10110001'						;czulosc minimum; stereo
	movwf tuner_data1
;						data.7=1 => mute
;						data.6=1 => search mode
;						data.5-data.0 - PLL[13:8]
	movlw b'00101010'									
	movwf tuner_data2	;1 bajt danych

;						data.7 - data.0 - PLL[7:0]
	movlw h'0F'
	movwf tuner_data3	; FM=88MHz
;
	clrf nr_stacji
	bcf buzer
;****************************************************************************************************************
;glowna petla programu
	btfsc key_mem
	goto menu0
	clrf adr_eeprom
	movlw h'00'
	call eeprom_write		;kasowanie pamieci eeprom - kom 00h:=00h
	call BEEP
	call BEEP
	call BEEP
	call BEEP
	call BEEP
menu
	call delay10
	btfss key_mem
	goto menu
	call delay10
menu0
	call delay10
	btfsc key_mono			
	goto menu0a
	call MONO_FUN			;zmiana tryby mono / stereo
menu0a
	btfsc ir_in
	goto menu0b
	movf adresh, 0
	movwf stos				;odlozenie adresh na stos
	clrf adr_eeprom
	call eeprom_read
	subwf nr_stacji, 0
	btfss status, Z
	goto menu0a2
	clrf nr_stacji
menu0a2
	incf nr_stacji, 1		;inkrementuj nr stacji
	movf nr_stacji, 0
;	movlw h'01'				;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movwf adr_eeprom
	call eeprom_read	
	movwf adresh
;	
	call FM_SERCH
	call TUNER
	movf stos, 0
	movwf adresh
menu0a1
	call delay10
	btfss ir_in
	goto menu0a1
	call delay100ms
	call delay100ms
	call delay100ms
menu0b
	btfsc key_mem
	goto menu0e
	clrf adr_eeprom
	call eeprom_read	;odczyt wskaznika adresu
	movwf licznik
	incf licznik, 1
menu0d
	movf licznik, 0		;W:=licznik - nowa ilosc stacji w eeprom		
	clrf adr_eeprom
	call eeprom_write	;zapis ilosci stacji
	movf licznik, 0		;W:=licznik - nowa ilosc stacji w eeprom		
	movwf adr_eeprom
	movf adresh, 0
	call eeprom_write	;czestotliwosci
	call BEEP
	call BEEP
menu0d1
	call delay10
	btfss key_mem
	goto menu0d1
	call delay10
	goto menu0e		
menu0e
	call var_pom		;pomiar napiecia varikapowego
	movf adresh, 0		;zapis wyniku pomiaru do W
	subwf var_mem, 0	;W:=var_mem-W
	btfsc status, Z		;skocz jesli adresh<>var_mem
	goto menu0
	movf adresh, 0
	movwf var_mem
	call FM_SERCH
	call TUNER
	clrf nr_stacji
	goto menu0
;****************************************************************
;FUNKCJE POMOCNICZE CD.
;*****************************************************************
;funkcja sprawdzania zajetosci i2c
i2c_wait
	banksel sspstat
	btfsc sspstat, R_W
	goto $-2
	banksel sspcon2
	movf sspcon2, w
	andlw h'1f'
	btfss status, z
	goto $-4
	bcf status, rp0		;bank 0
	bcf status, rp1		;bank 0
	return
;****************************************************************************
;wysylanie danych do tunera
TUNER
	banksel trisc	
	movlw b'00011000'			; 
	movwf trisc			;wyjscia
	banksel sspcon
	movlw b'00101000'			; 
	movwf sspcon			;
	banksel sspstat
	movlw b'10000000'			; 
	movwf sspstat
	banksel sspadd			;
	movlw h'7C'			; 
	movwf sspadd
;	bcf intcon, gie
	banksel sspcon2
	bsf sspcon2, sen	;start
	call i2c_wait
	movlw h'c0'			
	movwf sspbuf		;adres do zapisu TEA5767 
	call i2c_wait
	movf tuner_data2, 0				
	movwf sspbuf		;1 bajt danych
	call i2c_wait
	movf tuner_data3, 0				
	movwf sspbuf		;2 bajt danych
	call i2c_wait
;						data.7=1 =>szukanie w gore
;						data.6-data.5 => czuosc    00 - niedozwolony, 01 - czulosc max, 11 - czuosc min
;						data.4=1 => FM europe, 0=> FM Japon
;						data.3=1 => mono , 0=> stereo
;						data.2=1 => kana R - mute
;						data.1=1 => kana L - mute
;						data.0=1 => port spw ustawiony
;	movlw b'11111001'						;!!!!!!!!!!!!!!!!!!!!!!!!! czulosc min
	bsf tuner_data1, 3	;tylko mono
	movf tuner_data1, 0
	movwf sspbuf		;3 bajt danych
	call i2c_wait
;						data.7=1 => port spw2 ustawiony
;						data.6=1 => standby
;						data.5=1 => japon, 0 => europe
;						data.4 xtal = 1 32,7kHz 
;						data.3=1 =>soft mute on
;						data.2=1 =>obnizenie czestotliwosci granicznej przy slabym sygnale
;						data.1=1 => wyciszanie szumow przy slabym sygnale stereo
;						data.0=1 =>spw1 ustawiony gdy znajdzie stacje
	movlw b'10010001'			;			
	movwf sspbuf		;4 bajt danych
	call i2c_wait
;						data.7=0 > kwarc 32,7kHz
;						data.6=1 => deemfaza 75us, 0 => deemfaza 50us
;						data.5-data.0 = nc 
	movlw b'01000000'						
	movwf sspbuf		;5 bajt danych
	call i2c_wait
;
	banksel sspcon2
	bsf sspcon2, pen	;bit stop
	bcf status, rp0		;bank 0
	call i2c_wait
	call delay0255		;
	call delay0255		;
	return
;*****************************************************************************
;opoznienie o 255us
delay0255
	movlw h'46'	; 
	movwf dpl
delay0255_0				; funkcja opoxnienia 0 255us
	decfsz dpl, 0		;
	goto delay0255_1
	goto delay0255_end
delay0255_1
	movwf dpl
	goto delay0255_0
delay0255_end
	return
;opoznienie o 10 ms
delay10
	movlw h'0b'		;1 bylo 0bh
delay10a
	movwf dph		;1
	movlw h'f2'		;1
delay10b
	movwf dpl	;przepisuja W do dpl
	decfsz dpl,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay10b	;1
	movlw dph	;	wpisz do W dph
	decfsz dph,0	;1 zmniejsz dph, wynik do W, jesli 0 pomin next instr.
	goto delay10a	;1
	return	
;opoznienie o 100ms
delay100ms
	movwf stos3 	;zapamietuje W na stosie
	movlw .10
	movwf licznik
	call delay10
	decfsz licznik, 1
	goto $-2
	movf stos3, 0	;oddaje wartosc W
	return
;********************************************************
;pomiar napiecia varicapowego
var_pom
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	movlw h'81'			; 
	movwf adcon0 		;ADC on AN4 (RA5)
	call delay0255		;ustabilizowanie kluczy
	bsf adcon0, 2		;start pomiaru
	call delay0255
	btfsc adcon0, 2
	goto $-1
	return
;
;********************************************************************************
;przeskok do PC>2kB
;	nop
;	org h'800'
;********************************************************************************
;opoznienie o 255us
delay255
	movlw h'46'	; 
	movwf dpl
delay255_0				; funkcja opoxnienia 0 255us
	decfsz dpl, 0		;
	goto delay255_1
	goto delay255_end
delay255_1
	movwf dpl
	goto delay255_0
delay255_end
	return
;****************************************************************************************************************
;obsluga timera
timer0_int
	btfss buzer
	goto timer0_int1
	bcf buzer
	goto timer0_end
timer0_int1
	bsf buzer
timer0_end
	movlw h'C0'
	movf tmr0
	bcf intcon, tmr0if	;	zerowanie wskaxnika od przerwania	
	return
;*********************************************************************
;funkcja sprawdzania zajetosci i2c
i2c_wait1
	banksel sspstat
	btfsc sspstat, R_W
	goto $-1
	banksel sspcon2
	movf sspcon2, w		;wylacz dla proby
	andlw h'1f'
	btfss status, z
	goto $-3
	bcf status, rp0		;bank 0
	return
;*********************************************************************
MONO_FUN			;funkcja przlaczania mono / stereo
;	btfsc mono
;	goto MONO_FUN1
;	bsf mono
;	call FM_SERCH
;	call TUNER
;	goto MONO_FUN_END
;MONO_FUN1
;	bcf mono
;	call FM_SERCH
;	call TUNER
;MONO_FUN_END
;	call delay10
;	btfss key_mono
;	goto MONO_FUN_END
;	call delay10
	return
;
;*********************************************************************
;funkcja przeliczania czestotliwosci z Uvar
FM_SERCH
	movlw b'00101010'									
	movwf tuner_data2	;1 bajt danych
;						data.7 - data.0 - PLL[7:0]
	movlw h'0F'
	movwf tuner_data3	; FM=88MHz
	bcf status, rp0		;bank 0
	bcf status, rp1		;bank 0
	movf adresh, 0		;adresh do W
	call TEST_ZERO
	movwf licznik
	btfss licznik, 7	;adresh<>0	
	goto FM_SERCH_END	;fm=88MHz
	movf adresh, 0		;adresh do W
	movwf licznik
FM_SERCH1
	decf licznik, 1		;licznik=:licznik-1
	movf tuner_data3, 0
	addlw h'0A'
	movwf tuner_data3
	btfsc status, C
	incf tuner_data2, 1
	movf licznik, 0
	call TEST_ZERO
	movwf stos
	btfsc stos, 7
	goto FM_SERCH1 
FM_SERCH_END
	return
;****************************************************
;JESLI w=0 TO POZOSTAJE 0
;JESLI w<>0 TO w=80H
TEST_ZERO
	movwf stos
	movlw h'00'
	btfsc stos, 7
	goto TEST_ZERO_END	;BYLO 1
	btfsc stos, 6
	goto TEST_ZERO_END	;BYLO 1
	btfsc stos, 5
	goto TEST_ZERO_END	;BYLO 1
	btfsc stos, 4
	goto TEST_ZERO_END	;BYLO 1	
	btfsc stos, 3
	goto TEST_ZERO_END	;BYLO 1
	btfsc stos, 2
	goto TEST_ZERO_END	;BYLO 1
	btfsc stos, 1
	goto TEST_ZERO_END	;BYLO 1
	btfsc stos, 0
	goto TEST_ZERO_END	;BYLO 1
	goto TEST_ZERO_END1
TEST_ZERO_END	;BYLO 1
	movlw h'80'
TEST_ZERO_END1	;
	return
;******************************************************
MUTE_ON
	bsf tuner_data1, 1
	bsf tuner_data1, 2
	call TUNER
	return
MUTE_OFF
	bcf tuner_data1, 1
	bcf tuner_data1, 2
	call TUNER
	return
;odczyt z eeprom spod adr_eeprom, dana zapisana do W
eeprom_read
	bcf status, rp0 ;bank0
	bcf status, rp1 ;bank2
	movf adr_eeprom, 0
	bsf status, rp1 ;bank2
	movwf eeadr		;
;	incf eeadr, 1
	clrf eeadrh
	bsf status, rp0 ;bank3
	bcf eecon1, eepgd
	bsf eecon1, rd	;odczyt z eeprom
	btfsc eecon1, rd
	goto $-1
	bcf status, rp0 ;bank2
	movf eedata, 0	;przepisanie odczytanej danej do w
	clrf eeadr		;zerowy adres
	bcf status, rp1 ;bank0
;	movwf pom1
	return
;zapis do adresu adr_eeprom, dane w  W; 
eeprom_write
	bcf status, rp0 ;bank0
	bsf status, rp1 ;bank2
	movwf eedata	;wyslanie danych do eedata
	bcf status, rp1 ;bank0
	movf adr_eeprom, 0
	bsf status, rp1 ;bank2
	movwf eeadr		;
	clrf eeadrh
	bsf status, rp0 ;bank3
	bcf eecon1, eepgd
	bsf eecon1,wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1,wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
;
	bcf status, rp0 ;bank2
	clrf eeadr		;zerowy adres
;
	bcf status, rp1	;powrot do bank0
	return
;opoznienie 10us
delay10us
	goto $+1
	goto $+1
	goto $+1
	return
;pojedynczy dzwiek buzera
BEEP
	call MUTE_ON
	bsf intcon, gie
	call delay100ms
	call delay100ms
	bcf intcon, gie
	bcf buzer
	call MUTE_OFF
	call delay100ms
	call delay100ms
	return
;
	end